/* load.c */

#include <Pilot.h>

#include "life.h"

#define is_digit(c) ((c) >= '0' && (c) <= '9')

static Boolean get_num(const char *str, long strlen, long *pos, coord_t *value)
{
    Boolean neg = false;

    if (*pos + 1 >= strlen || str[*pos] != ' ') {
	return false;
    }

    if (str[++*pos] == '-') {
	neg = true;
	if (++*pos >= strlen) {
	    return false;
	}
    }

    if (! is_digit(str[*pos])) {
	return false;
    }

    *value = 0;
    do {
	*value = *value * 10 + str[*pos] - '0';
    } while (++*pos < strlen && is_digit(str[*pos]));

    if (neg) {
	*value = - *value;
    }

    return true;
}

offset_t load(const char *str, long strlen, cell_t *tape)
{
    long pos = 0;
    offset_t length = 0;
    coord_t x = 0, y = 0;

    while (pos < strlen) {
	if (str[pos] == '#') {
	    coord_t new_x, new_y;
	    if ((++pos < strlen && (str[pos] == 'P' || str[pos] == 'p'))
	     && ++pos < strlen
	     && get_num(str, strlen, &pos, &new_x)
	     && get_num(str, strlen, &pos, &new_y)) {
		x = new_x;
		y = new_y;
	    }
	} else if (str[pos] == '.' || str[pos] == '*') {
	    coord_t x1 = x;
	    while (pos < strlen && (str[pos] == '.' || str[pos] == '*')) {
		if (str[pos] == '*') {
		    if (tape == NULL) {
			++length;
		    } else {
			cell_t cell = CELL(x1, y);
			offset_t i;
			for (i = length; i > 0 && tape[i - 1] > cell; --i) {}
			if (i == 0 || (i > 0 && tape[i - 1] != cell)) {
			    if (i < length) {
				MemMove(tape + i + 1, tape + i,
					sizeof(cell_t) * (length - i));
			    }
			    tape[i] = cell;
			    ++length;
			}
		    }
		}
		++x1;
		++pos;
	    }
	    ++y;
	}

	while (pos < strlen && str[pos++] != '\n') {}
    }

    return length;
}
